#include <Carbon/Carbon.r>

#define Reserved8   reserved, reserved, reserved, reserved, reserved, reserved, reserved, reserved
#define Reserved12  Reserved8, reserved, reserved, reserved, reserved
#define Reserved13  Reserved12, reserved
#define dp_none__   noParams, "", directParamOptional, singleItem, notEnumerated, Reserved13
#define reply_none__   noReply, "", replyOptional, singleItem, notEnumerated, Reserved13
#define synonym_verb__ reply_none__, dp_none__, { }
#define plural__    "", {"", kAESpecialClassProperties, cType, "", reserved, singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, plural}, {}

resource 'aete' (0, "") {
	0x1,  // major version
	0x0,  // minor version
	english,
	roman,
	{
		"Standard Suite",
		"Common classes and commands for most applications.",
		'????',
		1,
		1,
		{
			/* Events */

			"open",
			"Open an object.",
			'aevt', 'odoc',
			reply_none__,
			'file',
			"The file(s) to be opened.",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{

			},

			"print",
			"Print an object.",
			'aevt', 'pdoc',
			reply_none__,
			'file',
			"The file(s) or document(s) to be printed.",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{

			},

			"quit",
			"Quit an application.",
			'aevt', 'quit',
			reply_none__,
			dp_none__,
			{
				"saving", 'savo', 'savo',
				"Specifies whether changes should be saved before quitting.",
				optional,
				singleItem, enumerated, Reserved13
			},

			"close",
			"Close an object.",
			'core', 'clos',
			reply_none__,
			'obj ',
			"the object to close",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"saving", 'savo', 'savo',
				"Specifies whether changes should be saved before closing.",
				optional,
				singleItem, enumerated, Reserved13,
				"saving in", 'kfil', 'file',
				"The file in which to save the object.",
				optional,
				singleItem, notEnumerated, Reserved13
			},

			"count",
			"Return the number of elements of a particular class within an object.",
			'core', 'cnte',
			'long',
			"the number of elements",
			replyRequired, singleItem, notEnumerated, Reserved13,
			'obj ',
			"the object whose elements are to be counted",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"each", 'kocl', 'type',
				"The class of objects to be counted.",
				optional,
				singleItem, notEnumerated, Reserved13
			},

			"delete",
			"Delete an object.",
			'core', 'delo',
			reply_none__,
			'obj ',
			"the object to delete",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{

			},

			"duplicate",
			"Copy object(s) and put the copies at a new location.",
			'core', 'clon',
			reply_none__,
			'obj ',
			"the object(s) to duplicate",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"to", 'insh', 'insl',
				"The location for the new object(s).",
				required,
				singleItem, notEnumerated, Reserved13,
				"with properties", 'prdt', 'reco',
				"Properties to be set in the new duplicated object(s).",
				optional,
				singleItem, notEnumerated, Reserved13
			},

			"exists",
			"Verify if an object exists.",
			'core', 'doex',
			'bool',
			"true if it exists, false if not",
			replyRequired, singleItem, notEnumerated, Reserved13,
			'obj ',
			"the object in question",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{

			},

			"get",
			"Get the data for an object.",
			'core', 'getd',
			'****',
			"",
			replyRequired, singleItem, notEnumerated, Reserved13,
			'obj ',
			"",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{

			},

			"make",
			"Make a new object.",
			'core', 'crel',
			'obj ',
			"to the new object",
			replyRequired, singleItem, notEnumerated, Reserved13,
			dp_none__,
			{
				"new", 'kocl', 'type',
				"The class of the new object.",
				required,
				singleItem, notEnumerated, Reserved13,
				"at", 'insh', 'insl',
				"The location at which to insert the object.",
				optional,
				singleItem, notEnumerated, Reserved13,
				"with data", 'data', '****',
				"The initial data for the object.",
				optional,
				singleItem, notEnumerated, Reserved13,
				"with properties", 'prdt', 'reco',
				"The initial values for properties of the object.",
				optional,
				singleItem, notEnumerated, Reserved13
			},

			"move",
			"Move object(s) to a new location.",
			'core', 'move',
			reply_none__,
			'obj ',
			"the object(s) to move",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"to", 'insh', 'insl',
				"The new location for the object(s).",
				required,
				singleItem, notEnumerated, Reserved13
			},

			"save",
			"Save an object.",
			'core', 'save',
			reply_none__,
			'obj ',
			"the object to save, usually a document or window",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"in", 'kfil', 'file',
				"The file in which to save the object.",
				optional,
				singleItem, notEnumerated, Reserved13,
				"as", 'fltp', 'TEXT',
				"The file type in which to save the data.",
				optional,
				singleItem, notEnumerated, Reserved13
			},

			"set",
			"Set an object's data.",
			'core', 'setd',
			reply_none__,
			'obj ',
			"",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{
				"to", 'data', '****',
				"The new value.",
				required,
				singleItem, notEnumerated, Reserved13
			}
		},
		{
			/* Classes */

			"item", 'cobj',
			"A scriptable object.",
			{
				"class", 'pcls', 'type',
				"The class of the object.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"properties", 'pALL', 'reco',
				"All of the object's properties.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12
			},
			{
			},
			"items", 'cobj', plural__,

			"application", 'capp',
			"An application's top level scripting object.",
			{
				"name", 'pnam', 'TEXT',
				"The name of the application.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"frontmost", 'pisf', 'bool',
				"Is this the frontmost (active) application?",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"version", 'vers', 'TEXT',
				"The version of the application.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12
			},
			{
				'docu', { },
				'cwin', { }
			},
			"applications", 'capp', plural__,

			"color", 'colr',
			"A color.",
			{
			},
			{
			},
			"colors", 'colr', plural__,

			"document", 'docu',
			"A document.",
			{
				"path", 'ppth', 'TEXT',
				"The document's path.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"modified", 'imod', 'bool',
				"Has the document been modified since the last save?",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"name", 'pnam', 'TEXT',
				"The document's name.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12
			},
			{
			},
			"documents", 'docu', plural__,

			"window", 'cwin',
			"A window.",
			{
				"name", 'pnam', 'TEXT',
				"The full title of the window.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"id", 'ID  ', 'nmbr',
				"The unique identifier of the window.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"bounds", 'pbnd', 'qdrt',
				"The bounding rectangle of the window.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"document", 'docu', 'docu',
				"The document whose contents are being displayed in the window.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"closeable", 'hclb', 'bool',
				"Whether the window has a close box.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"titled", 'ptit', 'bool',
				"Whether the window has a title bar.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"index", 'pidx', 'nmbr',
				"The index of the window in the back-to-front window ordering.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"floating", 'isfl', 'bool',
				"Whether the window floats.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"miniaturizable", 'ismn', 'bool',
				"Whether the window can be miniaturized.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"miniaturized", 'pmnd', 'bool',
				"Whether the window is currently miniaturized.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"modal", 'pmod', 'bool',
				"Whether the window is the application's current modal window.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"resizable", 'prsz', 'bool',
				"Whether the window can be resized.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"visible", 'pvis', 'bool',
				"Whether the window is currently visible.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"zoomable", 'iszm', 'bool',
				"Whether the window can be zoomed.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"zoomed", 'pzum', 'bool',
				"Whether the window is currently zoomed.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12
			},
			{
			},
			"windows", 'cwin', plural__
		},
		{
			/* Comparisons */
		},
		{
			/* Enumerations */
			'savo',
			{
				"yes", 'yes ', "Save the file.",
				"no", 'no  ', "Do not save the file.",
				"ask", 'ask ', "Ask the user whether or not to save the file."
			}
		},

		"Text Suite",
		"A set of basic classes for text processing.",
		'????',
		1,
		1,
		{
			/* Events */

		},
		{
			/* Classes */

			"text", 'ctxt',
			"Rich (styled) text",
			{
				"color", 'colr', 'colr',
				"The color of the first character.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"font", 'font', 'TEXT',
				"The name of the font of the first character.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"size", 'ptsz', 'nmbr',
				"The size in points of the first character.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12
			},
			{
				'cpar', { },
				'cwor', { },
				'cha ', { },
				'catr', { },
				'atts', { }
			},
			"text", 'ctxt', plural__,

			"attachment", 'atts',
			"Represents an inline text attachment.  This class is used mainly for make commands.",
			{
				"<Inheritance>", pInherits, 'ctxt',
				"inherits elements and properties of the text class.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"file name", 'atfn', 'TEXT',
				"The path to the file for the attachment",
				reserved, singleItem, notEnumerated, readWrite, Reserved12
			},
			{
			},
			"attachments", 'atts', plural__,

			"paragraph", 'cpar',
			"This subdivides the text into paragraphs.",
			{
				"<Inheritance>", pInherits, 'ctxt',
				"inherits elements and properties of the text class.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12
			},
			{
			},
			"paragraphs", 'cpar', plural__,

			"word", 'cwor',
			"This subdivides the text into words.",
			{
				"<Inheritance>", pInherits, 'ctxt',
				"inherits elements and properties of the text class.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12
			},
			{
			},
			"words", 'cwor', plural__,

			"character", 'cha ',
			"This subdivides the text into characters.",
			{
				"<Inheritance>", pInherits, 'ctxt',
				"inherits elements and properties of the text class.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12
			},
			{
			},
			"characters", 'cha ', plural__,

			"attribute run", 'catr',
			"This subdivides the text into chunks that all have the same attributes.",
			{
				"<Inheritance>", pInherits, 'ctxt',
				"inherits elements and properties of the text class.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12
			},
			{
			},
			"attribute runs", 'catr', plural__
		},
		{
			/* Comparisons */
		},
		{
			/* Enumerations */
		},

		"MarsEdit Suite",
		"",
		'MEbl',
		1,
		1,
		{
			/* Events */

			"send post to weblog",
			"Send the post to the weblog selected in the weblog popup menu.",
			'MEbl', 'Send',
			reply_none__,
			'obj ',
			"The post window to send to the weblog.",
			directParamRequired,
			singleItem, notEnumerated, Reserved13,
			{

			}
		},
		{
			/* Classes */

			"application", 'capp',
			"MarsEdits top level scripting object.",
			{
				"<Inheritance>", pInherits, 'capp',
				"inherits elements and properties of the application class.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"selected post", 'SePo', 'Post',
				"The current selected post or draft.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"selected weblog", 'SeWb', 'Wblg',
				"The current selected weblog.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12
			},
			{
				'Wblg', { }
			},
			"applications", 'capp', plural__,

			"post", 'Post',
			"",
			{
				"accept trackbacks", 'PsAp', 'bool',
				"Whether or not to accept trackbacks to the post. (For Movable Type compatible weblogs.)",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"body", 'PsBd', 'TEXT',
				"The body text of the post.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"category names", 'PsCa', 'TEXT',
				"The categories for the post.",
				reserved, listOfItems, notEnumerated, readOnly, Reserved12,

				"comment status", 'PsCs', 'long',
				"0 means no status set, 1 means open for comments, 2 means closed. (For Movable Type compatible weblogs.)",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"excerpt entry", 'PsEx', 'TEXT',
				"The excerpt (aka summary) for this post. (For Movable Type compatible weblogs.)",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"extended entry", 'PsEt', 'TEXT',
				"The extended entry for this post. (For Movable Type compatible weblogs.)",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"keywords", 'PsKw', 'TEXT',
				"The keywords for this post. (For Movable Type compatible weblogs.)",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"link", 'PsLk', 'TEXT',
				"The link entered for this post.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"permalink", 'PsPl', 'TEXT',
				"The permalink of this post on the web.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"post id", 'PsID', 'TEXT',
				"The id for this post on the weblog server.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"post to home page", 'PsHp', 'bool',
				"Whether or not the post appears on the home page. (For Radio UserLand only.)",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"text filter", 'PsTf', 'TEXT',
				"The text filter -- aka Formatting -- for this post. (For Movable Type compatible weblogs.)",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"title", 'Titl', 'TEXT',
				"The title of the post.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12
			},
			{
			},
			"posts", 'Post', plural__,

			"weblog", 'Wblg',
			"A weblog.",
			{
				"API call in progress", 'WbAc', 'bool',
				"True if MarsEdit is currently calling the weblog via XML-RPC or other method.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"API handler URL", 'WbRu', 'TEXT',
				"The URL of the API handler on the weblog (usually an XML-RPC script).",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"Blosxom folder path", 'WbBf', 'TEXT',
				"The path to the Blosxom folder.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"Blosxom script", 'WbBs', 'TEXT',
				"The script to run when sending a new or edited post to a Blosxom weblog.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"category names", 'PsCa', 'TEXT',
				"Names of categories for the weblog.",
				reserved, listOfItems, notEnumerated, readOnly, Reserved12,

				"encode with HTML entities", 'WbEe', 'bool',
				"Whether or not to encode text with HTML entities before sending to the weblog.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"home page URL", 'WbHu', 'TEXT',
				"The URL of the home page of the weblog.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"name", 'pnam', 'TEXT',
				"The name of the weblog.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"number of posts to download", 'WbNp', 'long',
				"The number of posts to download when refreshing the weblog.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"preview template", 'WbPr', 'TEXT',
				"The HTML template to use for previews.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"prompt for Blosxom filenames", 'WbBa', 'bool',
				"Whether or not to prompt for a filename when posting a new Blosxom post.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"system name", 'WbSy', 'TEXT',
				"Name of the publishing system this weblog uses.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"username", 'WbUn', 'TEXT',
				"Your username for the weblog.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"internal ID", 'WbUd', 'TEXT',
				"The internal identifier MarsEdit uses to uniquely identify the weblog.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"weblog ID", 'WbId', 'TEXT',
				"The ID of the weblog as stored on the server.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"use keychain", 'WbKc', 'bool',
				"Whether or not to store your password in the keychain.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12
			},
			{
				'Post', { }
			},
			"weblogs", 'Wblg', plural__,

			"post window", 'docu',
			"A post window.",
			{
				"<Inheritance>", pInherits, 'docu',
				"inherits elements and properties of the document class.",
				reserved, singleItem, notEnumerated, readOnly, Reserved12,

				"accept trackbacks", 'PsAp', 'bool',
				"Whether or not to accept trackbacks to the post. (For Movable Type compatible weblogs.)",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"body", 'PsBd', 'ctxt',
				"The body text.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"category names", 'PsCa', 'TEXT',
				"The categories for the post.",
				reserved, listOfItems, notEnumerated, readWrite, Reserved12,

				"comment status", 'PsCs', 'bool',
				"0 means no status set, 1 means open for comments, 2 means closed. (For Movable Type compatible weblogs.)",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"current text", 'PsCt', 'ctxt',
				"The current text view (one of body, extended, excerpt, or keywords).",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"current weblog", 'Dblg', 'Wblg',
				"The current weblog as specified in the Weblog popup.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"excerpt entry", 'PsEx', 'ctxt',
				"The contents of the excerpt entry text view.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"extended entry", 'PsEt', 'ctxt',
				"The contents of the extended entry text view.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"keywords", 'PsKw', 'ctxt',
				"The keywords for this post. (For Movable Type compatible weblogs.)",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"link", 'PsLk', 'TEXT',
				"The contents of the URL field.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"post to home page", 'PsHp', 'bool',
				"Whether or not the post should appear on the home page. (For Radio UserLand only.)",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"selected text", 'PsSt', 'TEXT',
				"The currently selected text in whichever text view is current.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"text filter", 'PsTf', 'TEXT',
				"The text filter -- aka Formatting -- for this post. (For Movable Type compatible weblogs.)",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"title", 'Titl', 'TEXT',
				"The contents of the Title field.",
				reserved, singleItem, notEnumerated, readWrite, Reserved12,

				"trackback links", 'Dtba', 'TEXT',
				"List of trackback links (URLs) to send with this post.",
				reserved, listOfItems, notEnumerated, readWrite, Reserved12
			},
			{
			},
			"post windows", 'docu', plural__
		},
		{
			/* Comparisons */
		},
		{
			/* Enumerations */
		},

		"Type Names Suite",
		"Hidden codes",
		kASTypeNamesSuite,
		1,
		1,
		{
			/* Events */

		},
		{
			/* Classes */

			"weblog", 'Wblg',
			"A weblog.",
			{
				"name", 'Wbdn', 'TEXT',
				"Alternate code for name",
				reserved, singleItem, notEnumerated, readOnly, Reserved12
			},
			{
			},
			"weblogs", 'Wblg', plural__
		},
		{
			/* Comparisons */
		},
		{
			/* Enumerations */
		}
	}
};
